import SeeksBaseLayouter from './SeeksBaseLayouter';
import { RGEventNames, RGForceLayoutOptions, RGLayoutOptions, RGNode, RGOptionsFull } from '../types';
import { RelationGraphFinal } from '../models/RelationGraphFinal';
type CalcNode = {
    rgNode: RGNode;
    Fx: number;
    Fy: number;
    x: number;
    y: number;
    ignoreForce: boolean;
    force_weight: number;
    forceCenterOffset_X: number;
    forceCenterOffset_Y: number;
    fixed: boolean;
};
export declare class SeeksForceLayouter extends SeeksBaseLayouter {
    layoutOptions: RGForceLayoutOptions;
    fastStart: boolean;
    maxLayoutTimes: number;
    byNode: boolean;
    byLine: boolean;
    lockX: boolean;
    lockY: boolean;
    force_node_repulsion: number;
    force_line_elastic: number;
    justLayoutSingleNode: boolean;
    stopWhenBalanced: boolean;
    constructor(layoutOptions: RGLayoutOptions, graphOptions: RGOptionsFull, graphInstance: RelationGraphFinal);
    refresh(): void;
    placeNodes(allNodes: RGNode[], rootNode?: RGNode): void;
    easyPlaceGroupNodes(rootNode: RGNode): RGNode[];
    easyAnalysisNodes(rootNode: RGNode): RGNode[];
    easyPlaceRelativePosition(rootNode: RGNode, groupNodes: RGNode[]): void;
    layoutTimes: number;
    prev10: number[];
    visibleNodes: RGNode[];
    updateVisibleNodes(allNode?: RGNode[]): void;
    viewUpdate(): void;
    autoLayout(forceLayout?: boolean): void;
    protected layoutFinished(): void;
    protected resetCalcNodes(): void;
    protected calcNodeMap: WeakMap<RGNode, CalcNode>;
    protected forCalcNodes: CalcNode[];
    protected recentGraphVelocity: number[];
    protected graphVelocityBalancedValue: number;
    doForceLayout(useTime: number): void;
    protected graphEventHandle(eventName: RGEventNames, ...args: any[]): void;
    protected _graphEventHandler: any;
    protected connectToGraphInstance(): void;
    protected disConnectToGraphInstance(): void;
    calcNodesPosition(): void;
    stop(): void;
    addElasticByLine(node1: CalcNode, node2: CalcNode, force_elastic?: number): void;
    maxVaildLineLength: number;
    minVaildLineLength: number;
    zeroEffectNodeDistance: number;
    minNodeDistance: number;
    maxMoveSpeed: number;
    addGravityByNode(node1: CalcNode, node2: CalcNode, coefficient?: number): void;
    addFtoNode(node: CalcNode, x: number, y: number): void;
    applyToNodePosition(node: CalcNode): number;
}
export default SeeksForceLayouter;
